SystemOrganization addCategory: #'DBZ tp'!

Object subclass: #Bueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Bueno methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 01:45'!
cedeSemilla:unGuerrero
unGuerrero cantidadSemillasHermitanio >0! !

Object subclass: #EnergiaMayor200
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!EnergiaMayor200 methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 02:16'!
metodo:unGuerrero 
unGuerrero energia >200! !

Object subclass: #Guerrero
	instanceVariableNames: 'energia puntosVida nivelPelea cantidadSemillasHermitanio coleccionSemillasHermitanio coleccionSemillas aliados bandoContrario puntosVidaPerdidos puntosAtaqueRecibidos puntosAtaquesRecibidos llevaPuesto recibeAtaque unTraje poderesConocidos cantidadAtaquesRecibidos ataquesRecibidos ataque unAtaque poder poderMaximo vidaPerdida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
agregarSemillaColeccion: unaSemilla 
	coleccionSemillasHermitanio add: unaSemilla! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados
	^ aliados! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados: unaBag 
	aliados := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliarCon: unGuerrero 
	(self puedeAliarse: unGuerrero)
			& (unGuerrero puedeAliarse: self)
		ifTrue: [aliados add: unGuerrero.
			unGuerrero aliados add: self].
	^ [aliados
		detect: [:guerrero | guerrero = unGuerrero]]
		ifError: [:exepcion | 'no puede aliarse baby']! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 16:49'!
aprende: unPoder 
	poderesConocidos add: unPoder! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:30'!
atacarCon:unPoder a: unGuerrero 
	unGuerrero recibe:unPoder.
	^ unGuerrero recibeAtaque! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:00'!
atacarConMaximoPoderA:unGuerrero

poderMaximo:= (poderesConocidos detectMax: [:unPoder 
| unPoder puntosAtaque:self ]).
 self atacarCon:poderMaximo a: unGuerrero.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos
	^ ataquesRecibidos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos: unaBag 
	ataquesRecibidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
bandoContrario
	^ bandoContrario! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
bandoContrario: unaBag 
	bandoContrario := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
calculoAtaquesRecibidos
	^ self ataquesRecibidos size // 3 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadAtaquesRecibidos: unaCant 
	cantidadAtaquesRecibidos := unaCant! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadSemillasHermitanio
	^ coleccionSemillasHermitanio size ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 01:44'!
coleccionSemillasHermitanio
^coleccionSemillasHermitanio! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionSemillasHermitanio: unaBag 
	coleccionSemillasHermitanio := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
come: semillaHermitanio 
	self puntosVida: 1000.
	self energia: self nivelPelea * 5 // 100 + self puntosExtra.
	coleccionSemillasHermitanio remove: semillaHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: ''!
energia
	^ energia! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
energia: unaCantidad 
	energia := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
estaMoribundo
	^ self puntosVida <= 50 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto
	^ llevaPuesto! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto: unTraje 
	llevaPuesto := unTraje! !

!Guerrero methodsFor: 'accessing' stamp: ''!
nivelPelea
	^ nivelPelea! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
nivelPelea: unNivel 
	nivelPelea := unNivel! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 01:54'!
pedir:unaSemilla A: unGuerrero 
(cantidadSemillasHermitanio = 0) & (self aliados includes: unGuerrero)  & (unGuerrero bando cedeSemilla) 

ifTrue: [ (unGuerrero coleccionSemillasHermitanio remove: unaSemilla) & (self coleccionSemillasHermitanio add: unaSemilla)]! !

!Guerrero methodsFor: 'accessing' stamp: 'maxi 10/10/2013 16:26'!
poderesConocidos
	^ poderesConocidos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
poderesConocidos: unaBag 
	poderesConocidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeAtacarA: unGuerrero 
	^ (self aliados includes: unGuerrero) not ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 02:10'!
puedeComer:unaSemilla
^ (coleccionSemillasHermitanio anySatisfy: [:semilla| semilla =unaSemilla]) & (self energia <200)
! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerPoder: unPoder 
	^ poderesConocidos anySatisfy: [:poder | poder = unPoder]
			& unPoder puedeHacerlo: self! !

!Guerrero methodsFor: 'accessing' stamp: ''!
puntosVida
	^ puntosVida + self vidaPerdida ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puntosVida: unaCantidad 
	puntosVida := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:36'!
recibe:Poder
	ataquesRecibidos add: unAtaque.
	 vidaPerdida:= poder puntosAtaque:self.
	 puntosVida:= self puntosVida + self vidaPerdida .
	! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:20'!
recibeAtaque
	ataquesRecibidos add: unAtaque.
	 puntosVida:=puntosVida + self vidaPerdida.
	
	^ recibeAtaque! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
recibeAtaque: unosPuntos 
	recibeAtaque := unosPuntos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
seMurio
	^ self puntosVida = 0! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
tieneEnergiaPara: unPoder 
	self energia > unPoder energiaNecesaria! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
vidaPerdida
	^ (llevaPuesto efecto: self)
		- self resistencia ! !

Guerrero subclass: #Monstruo
	instanceVariableNames: 'otroGuerrero puedeAliarse puntosPelea aliados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
bando
	^ Malo! !

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
puedeAliarse: unGuerrero 
	^ unGuerrero ~= self! !

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ 20 ! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: 'aliados bandoContrario puntosPelea oponentes bando'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados'!

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
bando
	^ bando! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
bando: unBando 
	bando := unBando! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
puedeAliarse: guerrero 
	^ (guerrero aliados
		sum: [:unAliado | unAliado nivelPelea])
		> self nivelPelea & (guerrero ~= self)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ 100 * aliados size! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ self recibeAtaque * 0.01 + self energia! !

Guerrero subclass: #Terricola
	instanceVariableNames: 'otroGuerrero puedeAliarse s aliados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
bando
	^ Bueno! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
puedeAliarse: unGuerrero 
	^ unGuerrero bando = Bueno & (unGuerrero ~= self)! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ self energia: self energia + 200! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ self puntosAtaqueRecibidos - self traje resistencia * 0.05 ! !

Object subclass: #Malo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Malo methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 01:45'!
cedeSemilla:unGuerrero
unGuerrero cantidadSemillasHermitanio >1! !

Object subclass: #PoderColectivos
	instanceVariableNames: 'minimoAliadosVivos energiaColectivaMinima'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
energiaColectivaMinima: unaCantidad 
	energiaColectivaMinima := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos
	^ minimoAliadosVivos! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos: unaCantidad 
	minimoAliadosVivos := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 200 & (self minimoAliadosVivos > 4) ! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ unGuerrero aliados size + energiaColectivaMinima + 200! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosAtaque unosAtaque potencia unAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
energiaNecesaria
	^ 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:09'!
potencia
^potencia! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:09'!
potencia:unaPotencia
potencia:=unaPotencia! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 50 ! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:15'!
puntosAtaque:unGuerrero
^ self potencia.! !

Object subclass: #PoderPotente
	instanceVariableNames: 'potenciaAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo
	^ true ! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'maxi 10/10/2013 17:10'!
puntosAtaque: unGuerrero 
	^unGuerrero nivelPelea / 500 * potenciaAtaque ! !

Object subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #SemillaHermitanio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #TrajeComun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeComun methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	^ 0.1! !

Object subclass: #TrajeEntrenamiento
	instanceVariableNames: 'calculoAtaquesRecibidos ataquesRecibidosA ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEntrenamiento methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	unGuerrero calculoAtaquesRecibidos > 0
		ifTrue: [unGuerrero nivelPelea: unGuerrero nivelPelea + (100 * unGuerrero calculoAtaquesRecibidos).
			unGuerrero energia: unGuerrero energia - 20]
		ifFalse: [unGuerrero energia: unGuerrero energia - 20].
	^ unGuerrero recibeAtaque! !

Object subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	^ unGuerrero recibeAtaque * 0.1 - 20! !
